<html>
	<!-- 
		trier les valeurs par tri à bulle et les écrire dans un fichier
	-->
	<head>
		<title>M2GPI</title>
		<style>
			body {
				display: flex;
				flex-direction: column;
			}
			#forms {
				margin: auto;
				display: flex;
				align-items: flex-end;
				align-content: space-between;
			}
			#results {
				margin: auto;
			}
			#tables {
				margin: auto;
				display: flex;
				align-content: space-between;
			}
			#forms > form {
				margin: 0 1em 0 1em;
			}
			#tables > div {
				margin: 0 5em 0 5em;;
			}
		</style>
	</head>
	<body>
		<?php
			function displayGenerateForm() : string {
				$string = 	
					'<form method="POST" action="rand_array.php">
						<input type="number" name="size" placeholder="number of entries"/><br>
						<input type="number" name="min" placeholder="minimum values"/><br>
						<input type="number" name="max" placeholder="maximal values"/><br>
						<input type="submit" name="generate" value="Generate array"/>
					</form>';
				return $string;
			}

			function displaySearchForm($array) : string {
				$string = 	
					'<form method="POST" action="rand_array.php">
					<input type="number" name="input" placeholder="value to find"/><br>
					<input type="submit" name="search" value="Search in array"/>';
				foreach($array as $value) {
					$string .= '<input type="hidden" name="array[]" value="' . $value . '">';
				}
				$string .= '</form>';
				return $string;
			}

			function displayArray($array) : string {
				$string = "<table><tr><th>Index</th><th>Value</th></tr>";
				$count = count($array);
				for ($i=0; $i < $count; $i++) { 
					$string .= "<tr><td>" . $i . "</td>";
					$string .= "<td>" . $array[$i] . "</td></tr>";
				}
				$string .= "</table>";
				return $string;
			}

			function generateRandArray($size = 20, $min = 1, $max = 1000) : array {
				$array = array();
				for ($i=0; $i < $size; $i++) { 
					$array[] = rand($min, $max);
				}
				return $array;
			}

			function calculateAverage($array) : int {
				$int = (int)0;
				$count = count($array);
				for ($i=0; $i < $count; $i++) { 
					$int = $int + $array[$i];
				}
				$int = $int / count($array);
				return $int;
			}

			function calculateMinimum($array) : int {
				$int = $array[0];
				$count = count($array);
				for ($i=0; $i < $count; $i++) { 
					if ($array[$i] < $int) {
						$int = $array[$i];
					}
				}
				return $int;
			}

			function calculateMaximum($array) : int {
				$int = $array[0];
				$count = count($array);
				for ($i=0; $i < $count; $i++) { 
					if ($array[$i] > $int) {
						$int = $array[$i];
					}
				}
				return $int;
			}

			function bubbleSort($array) : array {
				$temp = (int)0;
				$count = count($array);
				$swapped = (bool)true;
				while ($swapped) {
					$swapped = false;
					$count = $count - 1;
					for ($i=0; $i < $count; $i++) { 
						if ($array[$i] > $array[$i + 1]) {
							$swapped = true;
							$temp = $array[$i + 1];
							$array[$i + 1] = $array[$i];
							$array[$i] = $temp;
						}
					}
				}
				return $array;
			}

			function searchValue($value, $array) : int {
				$min = (int)0;
				$max = count($array) - 1;
				while ($min <= $max) {
					$index = floor(($min + $max) / 2);
					if ($array[$index] == $value) {
						return $index;
					} elseif ($array[$index] < $value) {
						$min = $index + 1;
					} elseif ($array[$index] > $value) {
						$max = $index - 1;
					}
				}
				return -1;
			}

			function writeArrayValuesToFile($array, $path) : bool {
				if ($file = fopen($path, 'a')) {
					try {
						fputs($file, chr(10) . date("H:i:s"));
						for ($i=0; $i < count($array); $i++) { 
							fputs($file, $array[$i] . chr(10));
						}
					} catch (Exception $e) {
						echo 'Caught exception: ',  $e->getMessage(), "\n";
					} finally {
						fclose($file);
					}
					return true;
				}
				return false;
			}

			if (isset($_POST['search']) && $_POST['input'] && $_POST['array']) {
				$input = $_POST['input'];
				$array = $_POST['array'];
			} elseif (isset($_POST['generate']) && $_POST['size'] && $_POST['min'] && $_POST['max']) {
				$array = generateRandArray($_POST['size'], $_POST['min'], $_POST['max']);
			} else {
				$array = generateRandArray();
			}
			$sortedArray = bubbleSort($array);
			$path = './rand_array_to_file.txt';

			echo '<h1>M2GPI2024 Algorithmie</h1>';
			echo '<div id="forms">';
			echo displayGenerateForm();
			echo displaySearchForm($array);
			echo '</div><div id="results">';
			echo '<h3>Results</h3>';
			echo "<p>Average value is " . calculateAverage($array) . "</p>";
			echo "<p>Smallest value is " . calculateMinimum($array) . "</p>";
			echo "<p>Largest value is " . calculateMaximum($array) . "</p>";
			if (writeArrayValuesToFile($sortedArray, $path)) {
				echo "<p>Values saved to <br>'" . $path . "'</p>";
			} else {
				echo "<p>Couldn't save values to <br>'" . $path . "'</p>";
			}
			if (isset($input)) {
				$result = searchValue($input, $sortedArray);
				if ($result > -1) {
					echo "Value " . $input . " exists at index " . $result;
				} else {
					echo "Value " . $input . " doesn't exist";
				}
			}
			echo '</div><div id="tables">';
			echo '<div><h3>Unordered</h3>';
			echo displayArray($array);
			echo '</div><div><h3>Ordered</h3>';
			echo displayArray($sortedArray);
			echo '</div></div>';
		?>
	</body>
</html>